VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "bnetchat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Const ID_EMOTE = &H17
Private Const ID_WHISPTO = &HA
Private Const ID_WHISPFROM = &H4
Private Const ID_TALK = &H5
Private Const ID_USER = &H1
Private Const ID_JOIN = &H2
Private Const ID_LEAVE = &H3
Private Const ID_FLAGS = &H9
Private Const ID_CHAN = &H7
Private Const ID_ERROR = &H13
Private Const ID_INFO = &H12
Private Const ID_BROADCAST = &H6

Public Event OnUser(ByVal Username As String, ByVal Flags As Long, ByVal message As String, ByVal ping As Long)
Public Event OnJoin(ByVal Username As String, ByVal Flags As Long, ByVal message As String, ByVal ping As Long)
Public Event OnLeave(ByVal Username As String, ByVal Flags As Long)
Public Event OnWhisperFrom(ByVal Username As String, ByVal Flags As Long, ByVal message As String)
Public Event OnTalk(ByVal Username As String, ByVal Flags As Long, ByVal message As String, ByVal ping As Long)
Public Event OnChannel(ByVal ChannelName As String)
Public Event OnFlags(ByVal Username As String, ByVal Flags As Long, ByVal message As String, ByVal ping As Long)
Public Event OnWhisperTo(ByVal Username As String, ByVal Flags As Long, ByVal message As String, ByVal ping As Long)
Public Event OnInfo(ByVal message As String)
Public Event OnError(ByVal message As String)
Public Event OnEmote(ByVal Username As String, ByVal Flags As Long, ByVal message As String)
Public Event OnUnknown(ByVal UnknownString As String)


Public Sub BCHAT(ByVal databuf As String)
Dim EID As Long, ping As Long, Username As String, message As String
    EID = MakeLong(Mid$(databuf, 5, 4))
    Flags = MakeLong(Mid$(databuf, 9, 4))
    ping = MakeLong(Mid$(databuf, 13, 4))
Username = KillNull(Mid$(databuf, 29))
message = KillNull(Mid$(databuf, Len(Username) + 30))
Select Case EID
Case ID_TALK
RaiseEvent OnTalk(Username, Flags, message, ping)
Case ID_EMOTE
RaiseEvent OnEmote(Username, Flags, message)
Case ID_CHAN
RaiseEvent OnChannel(message)
Case ID_USER
RaiseEvent OnUser(Username, Flags, message, ping)
Case ID_JOIN
RaiseEvent OnJoin(Username, Flags, message, ping)
Case ID_LEAVE
RaiseEvent OnLeave(Username, Flags)
Case ID_WHISPTO
RaiseEvent OnWhisperTo(Username, Flags, message, ping)
Case ID_WHISPFROM
RaiseEvent OnWhisperFrom(Username, Flags, message)
Case ID_INFO
RaiseEvent OnInfo(message)
Case ID_FLAGS
RaiseEvent OnFlags(Username, Flags, message, ping)
Case ID_BROADCAST
RaiseEvent OnInfo(message)
Case ID_ERROR
RaiseEvent OnError(message)
Case Else
RaiseEvent OnUnknown(message)
End Select
End Sub
Function MakeLong(x As String) As Long
    If Len(x) < 4 Then
        Exit Function
    End If
    CopyMemory MakeLong, ByVal x, 4
End Function
'needed subs
