Attribute VB_Name = "Parsing"
Option Explicit
Public Declare Function CheckRevision Lib "CheckRevision.dll" Alias "_CheckRevision@32" (ByVal FileExe As String, ByVal FileStormDll As String, ByVal FileBnetDll As String, ByVal HashText As String, ByRef version As Long, ByRef Checksum As Long, ByVal ExeInfo As String, ByVal mpqname As String) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numbytes As Long)
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Declare Sub HashCDKey Lib "Hash.dll" Alias "?HashCDKey@@YGXPAK0000@Z" (ByRef lngKey As Long, ByRef lngSeed As Long, ByRef lngProdID As Long, ByRef lngValue1 As Long, ByRef lngValue2 As Long)
Public Declare Sub HashPass Lib "Hash.dll" Alias "?HashPassword@@YGXPBDHPAK1111@Z" (ByVal password As String, ByVal nLength As Integer, ByRef lngSeed As Long, ByRef lngKey As Long, ByRef Value1 As Long, ByRef lngValue2 As Long, ByRef lngValue3 As Long)
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Const blue = 12092001
Public Const HWND_TOPMOST = -1
Public pbuffer As New PacketBuffer
Private socket As Winsock
Public varCDkey As String
Public varProduct As String
Public varServer As String
Public varUser As String
Public varPass As String
Public varhome As String
Public verByte As String
Public varCDkey2 As String
Public varProduct2 As String
Public varServer2 As String
Public varUser2 As String
Public varPass2 As String
Public varhome2 As String
Public connected As Boolean
Public exeN As String
Public varFiles As String
Public serverhash As String
Dim hash As String, mpqname As String
Sub Main()
    Dim OldTitle$
    Form1.Show
    End Sub
Public Sub Setup()
On Error Resume Next
 Select Case varProduct
        Case "RATS"
            verByte = "C7"
            exeN = "starcraft"
            varFiles = App.Path & "\Star\"
        Case "PXES"
            verByte = "C7"
            exeN = "starcraft"
            varFiles = App.Path & "\Star\"
        Case "NB2W"
            verByte = "4F"
            exeN = "Warcraft II BNE"
            varFiles = App.Path & "\War2\"
        Case "RHSS"
            verByte = "A5"
            exeN = "starcraft"
            varFiles = App.Path & "\SSHR\"
        Case "RTSJ"
            verByte = "A9"
            exeN = "StarCraftJ"
            varFiles = App.Path & "\JSTR\"
    End Select
   End Sub

Public Function StrToHex(ByVal string1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, i As Long
    
    For i = 1 To Len(string1)
        strTemp = Hex(Asc(Mid(string1, i, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    
    strReturn = strReturn & " " & strTemp
    
    Next i
        StrToHex = strReturn
    
End Function

Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double)
On Error Resume Next
    sCDKey = Replace(sCDKey, "-", "")
    sCDKey = Replace(sCDKey, " ", "")
    sCDKey = KillNull(sCDKey)
    
    If Len(sCDKey) = 13 Then
        sCDKey = DecodeStarcraftKey(sCDKey)
    ElseIf Len(sCDKey) = 16 Then
        sCDKey = DecodeD2Key(sCDKey)
    Else
        Exit Sub
    End If
    
    dProductId = Val("&H" & Left$(sCDKey, 2))
    
    If Len(sCDKey) = 13 Then
        dValue1 = Val(Mid$(sCDKey, 3, 7))
        dValue2 = Val(Mid$(sCDKey, 10, 3))

    ElseIf Len(sCDKey) = 16 Then
        dValue1 = Val("&H" & Mid$(sCDKey, 3, 6))
        dValue2 = Val("&H" & Mid$(sCDKey, 9))
    End If
    
End Sub

Public Function DecodeD2Key(ByVal key As String) As String
    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    C As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    r = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or r
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        r = LShift(r, 1)
        
Cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        C = GetNumValue(aryKey(i))
        n = Val(C)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        C = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(C)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        C = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(C)
        
        If Val(C) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor C
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(C) < Asc("A") Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor C
            aryKey(i) = Chr$(c2)
            
        End If
        
    Next i
    
    DecodeD2Key = Join(aryKey, "")
    
    Erase aryKey()
    
End Function

Public Function DecodeStarcraftKey(ByVal sKey As String) As String
On Error Resume Next
    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, C As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    
    For i = 1 To 13
    
        aryKey(i - 1) = Mid$(sKey, i, 1)
        
    Next i
    
    v = 3
    
    For i = 0 To 11
    
        C = aryKey(i)
        n = Val(C)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v Mod 10
    
    If Hex(v) = aryKey(12) Then
    
        bValid = True
        
    End If
    
    v = 194
    
    For i = 11 To 0 Step -1
    
        If v < 7 Then GoTo continue
        C = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = C
        
    Next i
    
continue:

    v2 = &H13AC9741
    
    For i = 11 To 0 Step -1
    
        C = UCase$(aryKey(i))
        aryKey(i) = C
        
        If Asc(C) <= Asc("7") Then
        
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor C
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
            
        ElseIf Asc(C) < 65 Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor C
            aryKey(i) = c2
            
        End If
        
    Next i
    
    DecodeStarcraftKey = Join(aryKey, "")
    
    Erase aryKey()
    
End Function





Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
LShift = CDbl(pnValue * (2 ^ pnShift))
End Function


Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function


Public Function TimeStamp(Optional ByVal sTime As String)
On Error Resume Next
TimeStamp = "[" & Time() & "] "

End Function
Private Function Hex2Dec(ByVal sHex As String) As Long
On Error Resume Next
    Dim i As Integer
    Dim nDec As Long
    Const HexChar As String = "0123456789ABCDEF"
    


    For i = Len(sHex) To 1 Step -1
        nDec = nDec + (InStr(1, HexChar, Mid(sHex, i, 1)) - 1) * 16 ^ (Len(sHex) - i)
    Next i
    Hex2Dec = CStr(nDec)
End Function
Public Function KillNull(ByVal text As String) As String
    Dim i As Integer
    i = InStr(1, text, Chr(0))
    If i = 0 Then
        KillNull = text
        Exit Function
    End If
    KillNull = Left(text, i - 1)
End Function


Public Function FlagsIDsplt(strdata As String) As String
    FlagsIDsplt = Hex(Asc(Mid(strdata, 9, 1)))
End Function
Public Function getping(strdata As String) As Long
On Error Resume Next
Dim strPing As String
strPing$ = Mid$(strdata, 13, 4)
CopyMemory getping, ByVal strPing$, 4
End Function

Public Function CVL(x As String) As Long
On Error Resume Next
    If Len(x) < 4 Then
        MsgBox "CVL(): String too short"
        Stop
    End If
    CopyMemory CVL, ByVal x, 4
End Function


' Converts a string to an Integer
Private Function CVI(x As String) As Integer
On Error Resume Next
    If Len(x) < 2 Then
        MsgBox "CVI(): String too short"
        Stop
    End If
    
    CopyMemory CVI, ByVal x, 2
End Function
Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    
    If v < 10 Then
    
        GetHexValue = Chr$(v + &H30)
        
    Else
    
        GetHexValue = Chr$(v + &H37)
        
    End If
    
End Function

Public Function GetNumValue(ByVal C As String) As Long
On Error Resume Next
    C = UCase(C)
    
    If IsNumeric(C) Then
    
        GetNumValue = Asc(C) - &H30
        
    Else
    
        GetNumValue = Asc(C) - &H37
        
    End If
    
End Function
Public Sub NullTruncString(ByRef text As String)
On Error Resume Next
    Dim i As Integer
    
    i = InStr(text, Chr(0))
    If i = 0 Then Exit Sub
    
    text = Left(text, i - 1)
End Sub
Function mfncGetFromIni(strSectionHeader As String, strVariableName As String, strFileName As String) As String
   On Error Resume Next
    '*** DESCRIPTION:Reads from an *.INI fil
    '     e strFileName (full path &file name)
    '*** RETURNS:The string stored in [strSe
    '     ctionHeader], linebeginning strVariableName=
    '*** NOTE: Requires declaration of API c
    '     allGetPrivateProfileString
    'Initialise variable
    Dim strReturn As String
    'Blank the return string
    strReturn = String(255, Chr(0))
    'Get requested information, trimming the
    '     returned string
    mfncGetFromIni = Left$(strReturn, GetPrivateProfileString(strSectionHeader, ByVal strVariableName, "", strReturn, Len(strReturn), strFileName))
End Function
Function mfncParseString(strIn As String, intOffset As Integer, strDelimiter As String) As String
  On Error Resume Next
    '*** DESCRIPTION:Parses the passed strin
    '     g, returning the valueindicated
    '***by the offset specified, eg: the str
    '     ing "Hello,World ","
    '***offset 2 = "World".
    '*** RETURNS:See description.
    '*** NOTE: The offset starts at 1 and th
    '     e delimiter is theCharacter
    '***which separates the elements of the
    '     string.
    'Trap any bad calls
    If Len(strIn) = 0 Or intOffset = 0 Then
        mfncParseString = ""
        Exit Function
    End If
    'Declare local variables
    Dim intStartPos As Integer
    ReDim intDelimPos(10) As Integer
    Dim intStrLen As Integer
    Dim intNoOfDelims As Integer
    Dim intCount As Integer
    Dim strQuotationMarks As String
    Dim intInsideQuotationMarks As Integer
    strQuotationMarks = Chr(34) & Chr(147) & Chr(148)
    intInsideQuotationMarks = False
    For intCount = 1 To Len(strIn)
        'If character is a double-quote then tog
        '     gle the In Quotation flag
        If InStr(strQuotationMarks, Mid$(strIn, intCount, 1)) <> 0 Then
            intInsideQuotationMarks = (Not intInsideQuotationMarks)
        End If
        If (Not intInsideQuotationMarks) And (Mid$(strIn, intCount, 1) = strDelimiter) Then
        intNoOfDelims = intNoOfDelims + 1
        'If array filled then enlarge it, keepin
        '     g existing contents
        If (intNoOfDelims Mod 10) = 0 Then
            ReDim Preserve intDelimPos(intNoOfDelims + 10)
        End If
        intDelimPos(intNoOfDelims) = intCount
    End If
Next intCount
'Handle request for value not present (o
'     ver-run)
If intOffset > (intNoOfDelims + 1) Then
    mfncParseString = ""
    Exit Function
End If
'Handle boundaries of string
If intOffset = 1 Then
    intStartPos = 1
End If
'Requesting last value - handle null
If intOffset = (intNoOfDelims + 1) Then
    If Right$(strIn, 1) = strDelimiter Then
        intStartPos = -1
        intStrLen = -1
        mfncParseString = ""
        Exit Function
    Else
        intStrLen = Len(strIn) - intDelimPos(intOffset - 1)
    End If
End If
'Set start and length variables if not h
'     andled by boundary check above
If intStartPos = 0 Then
    intStartPos = intDelimPos(intOffset - 1) + 1
End If
If intStrLen = 0 Then
    intStrLen = intDelimPos(intOffset) - intStartPos
End If
'Set the return string
mfncParseString = Mid$(strIn, intStartPos, intStrLen)
End Function


Public Function HexToStr(ByVal Hex1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, i As Long
    If Len(Hex1) Mod 2 <> 0 Then Exit Function
    For i = 1 To Len(Hex1) Step 2
    strReturn = strReturn & Chr(Val("&H" & Mid(Hex1, i, 2)))
    Next i
    HexToStr = strReturn
End Function

Public Sub cmdrejoin(channel As String)
On Error Resume Next
pbuffer.sendPacket &H10
pbuffer.InsertDWORD &H2
pbuffer.InsertNTString channel
pbuffer.sendPacket &HC
End Sub

Public Sub Profile(Data As String)
On Error Resume Next
Dim x As Integer
'''Form3.age.text = ""
'''Form3.description.text = ""

'''Form3.sex.text = ""
 Dim ProfileEnd As String
     Dim SplitProfile As Variant
     Dim splt() As String
     ProfileEnd = Mid(Data, 17, Len(Data))
     SplitProfile = Split(ProfileEnd, Chr(&H0))
     splt() = Split(SplitProfile(3), vbCrLf)
     '''Form3.age.text = SplitProfile(0) & vbCrLf
     '''Form3.sex.text = SplitProfile(1) & vbCrLf
     '''Addsex vbWhite, SplitProfile(2) & vbCrLf
     If InStr(SplitProfile(3), vbCrLf) Then
     For x = 0 To UBound(splt())
     '''Adddes vbWhite, splt(x) & vbCrLf
     Next x
     Else
     '''Adddes vbWhite, SplitProfile(3) & vbCrLf
     End If
     '''Form3.Show
End Sub

Public Sub RequestProfile(strUser As String, game As String, user As String, user2 As String)
'''Form3.aaname.text = user
If LCase(user) = LCase(user2) Then
'Form3.age.Locked = False
'Form3.description.Locked = False
'Form3.location.Locked = False
'Form3.sex.Locked = False
'Form3.Command1.Enabled = True
Else
'Form3.age.Locked = True
'Form3.description.Locked = True
'Form3.location.Locked = True
'Form3.sex.Locked = True
'Form3.Command1.Enabled = False
End If
    Dim lngKey As Long
    lngKey = GetTickCount()
    Dim PacketBuf As New PacketBuffer
    PacketBuf.InsertDWORD 1
    PacketBuf.InsertDWORD 18
    PacketBuf.InsertDWORD lngKey
    PacketBuf.InsertNTString strUser
    PacketBuf.InsertNTString "profile\age"
    PacketBuf.InsertNTString "profile\sex"
    PacketBuf.InsertNTString "profile\location"
    PacketBuf.InsertNTString "profile\description"
    PacketBuf.InsertNTString "Record\" & game & "\0\wins"
    PacketBuf.InsertNTString "Record\" & game & "\0\losses"
    PacketBuf.InsertNTString "Record\" & game & "\0\disconnects"
    PacketBuf.InsertNTString "Record\" & game & "\0\last game"
    PacketBuf.InsertNTString "Record\" & game & "\0\last game result"
    PacketBuf.InsertNTString "Record\" & game & "\1\wins"
    PacketBuf.InsertNTString "Record\" & game & "\1\losses"
    PacketBuf.InsertNTString "Record\" & game & "\1\disconnects"
    PacketBuf.InsertNTString "Record\" & game & "\1\last game"
    PacketBuf.InsertNTString "Record\" & game & "\1\last game result"
    PacketBuf.InsertNTString "Record\" & game & "\1\rating"
    PacketBuf.InsertNTString "Record\" & game & "\1\high rating"
    PacketBuf.InsertNTString "Record\" & game & "\1\rank"
    PacketBuf.InsertNTString "Record\" & game & "\1\high rank"
    PacketBuf.sendPacket &H26
    'ProfUsrVar = strUser
End Sub
Public Sub Delay(HowLong As Date)
Dim temptime
temptime = DateAdd("s", HowLong, Now)
While temptime > Now
DoEvents
Wend
End Sub

Public Sub SetProfile(Username As String, age As String, sex As String, location As String, description As String)
' Please note, you can use  'vbnewline' to add lines!
    With Form1.PacketBuf
     .InsertDWORD 1
     .InsertDWORD 4
     .InsertNTString Username
     .InsertNTString "profile\sex"
     .InsertNTString "profile\age"
     .InsertNTString "profile\location"
     .InsertNTString "profile\description"
     .InsertNTString sex
     .InsertNTString age
     .InsertNTString location
     .InsertNTString description
     .sendPacket &H27
    End With
End Sub


